Package org.apache.sling.commons.compiler

## Class Options

- java.lang.Object
- - java.util.AbstractMap<K,​V>
  - - java.util.HashMap<String,​Object>
    - - org.apache.sling.commons.compiler.Options

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `Map<String,​Object>`

    public class Options
    extends HashMap<String,​Object>

Options for the compilation process.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class java.util.AbstractMap

`AbstractMap.SimpleEntry<K extends Object,​V extends Object>, AbstractMap.SimpleImmutableEntry<K extends Object,​V extends Object>`

### Nested classes/interfaces inherited from interface java.util.Map

`Map.Entry<K extends Object,​V extends Object>`

### Field Summary

Fields
`static String` `KEY_ADDITIONAL_CLASS_LOADER` The key for the additional class loader.
`static String` `KEY_CLASS_LOADER` The key for the class loader.
`static String` `KEY_CLASS_LOADER_WRITER` The key for the class loader writer.
`static String` `KEY_FORCE_COMPILATION` The key to force the compilation - even if the class files are more recent.
`static String` `KEY_GENERATE_DEBUG_INFO` The key for the generate debug info flag.
`static String` `KEY_IGNORE_WARNINGS` The key to ignore warnings - if this option is turned on, the resulting compilation result does not get the warnings issued by the compiler.
`static String` `KEY_SOURCE_VERSION` The key for the source version.
`static String` `KEY_TARGET_VERSION` The key for the target version.
`static String` `VERSION_1_1`
`static String` `VERSION_1_2`
`static String` `VERSION_1_3`
`static String` `VERSION_1_4`
`static String` `VERSION_1_5`
`static String` `VERSION_1_6`
`static String` `VERSION_1_7`
`static String` `VERSION_1_8`
`static String` `VERSION_RUNTIME`

### Constructor Summary

Constructors
`Options()` Default options with the following presets: - generate debug info : true
`Options​(Options options)` Create a new options object based on an existing one.

### Method Summary

All Methods Instance Methods Concrete Methods
`String` `getSourceVersion()` Get the source version.
`String` `getTargetVersion()` Get the target version.
`boolean` `isGenerateDebugInfo()` Should debug info be generated?

### Methods inherited from class java.util.HashMap

`clear, clone, compute, computeIfAbsent, computeIfPresent, containsKey, containsValue, entrySet, forEach, get, getOrDefault, isEmpty, keySet, merge, put, putAll, putIfAbsent, remove, remove, replace, replace, replaceAll, size, values`

### Methods inherited from class java.util.AbstractMap

`equals, hashCode, toString`

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.util.Map

`equals, hashCode`

### Field Detail

#### KEY_SOURCE_VERSION

    public static final String KEY_SOURCE_VERSION

The key for the source version.

See Also:
  Constant Field Values

#### KEY_TARGET_VERSION

    public static final String KEY_TARGET_VERSION

The key for the target version.

See Also:
  Constant Field Values

#### KEY_GENERATE_DEBUG_INFO

    public static final String KEY_GENERATE_DEBUG_INFO

The key for the generate debug info flag.

See Also:
  Constant Field Values

#### VERSION_RUNTIME

    public static final String VERSION_RUNTIME

#### VERSION_1_1

    public static final String VERSION_1_1

See Also:
  Constant Field Values

#### VERSION_1_2

    public static final String VERSION_1_2

See Also:
  Constant Field Values

#### VERSION_1_3

    public static final String VERSION_1_3

See Also:
  Constant Field Values

#### VERSION_1_4

    public static final String VERSION_1_4

See Also:
  Constant Field Values

#### VERSION_1_5

    public static final String VERSION_1_5

See Also:
  Constant Field Values

#### VERSION_1_6

    public static final String VERSION_1_6

See Also:
  Constant Field Values

#### VERSION_1_7

    public static final String VERSION_1_7

See Also:
  Constant Field Values

#### VERSION_1_8

    public static final String VERSION_1_8

See Also:
  Constant Field Values

#### KEY_CLASS_LOADER_WRITER

    public static final String KEY_CLASS_LOADER_WRITER

The key for the class loader writer. By default the registered class loader writer service is used.

See Also:
  Constant Field Values

#### KEY_CLASS_LOADER

    public static final String KEY_CLASS_LOADER

The key for the class loader. By default the commons dynamic classloader is used. This property overrides the classloader and ignores the `KEY_ADDITIONAL_CLASS_LOADER` completly!

See Also:
  Constant Field Values

#### KEY_ADDITIONAL_CLASS_LOADER

    public static final String KEY_ADDITIONAL_CLASS_LOADER

The key for the additional class loader. By default the commons dynamic classloader is used. If this property is used and the `KEY_CLASS_LOADER` property is not defined, a classloader with the dynamic class loader (default) and the class loader specified here is used.

See Also:
  Constant Field Values

#### KEY_FORCE_COMPILATION

    public static final String KEY_FORCE_COMPILATION

The key to force the compilation - even if the class files are more recent. The value should be of type Boolean.

See Also:
  Constant Field Values

#### KEY_IGNORE_WARNINGS

    public static final String KEY_IGNORE_WARNINGS

The key to ignore warnings - if this option is turned on, the resulting compilation result does not get the warnings issued by the compiler. The value should be of type Boolean.

See Also:
  Constant Field Values

### Constructor Detail

#### Options

    public Options()

Default options with the following presets: - generate debug info : true

#### Options

    public Options​(Options options)

Create a new options object based on an existing one.

Parameters:
  `options` - The base options.

### Method Detail

#### getSourceVersion

    public String getSourceVersion()

Get the source version.

Returns:
  The source version.

#### getTargetVersion

    public String getTargetVersion()

Get the target version.

Returns:
  The target version
Since:
  2.0

#### isGenerateDebugInfo

    public boolean isGenerateDebugInfo()

Should debug info be generated?

Returns:
  `true` if debug info should be generated.